/*
  GoodFields tutoriel_4 
  FRONT MONTANT/DESCENDANT
  TEMPORISATION basique
  GRAFCET
*/
 
//**********************************************************
// DECLARATIONS
// entrées-sorties
int led = 13;
int bp = 2;
int bp_etat, bp_memoire;
// vitesse de clignotement
int demiperiode=25000;
// temporisations
int tempo_a;
// GRAFCETS
int grafcet_a;

//**********************************************************
// INITIALISATIONS
void setup() {                
// initialize the digital pins
  pinMode(led, OUTPUT);     
  pinMode(bp, INPUT);     
// ligne série (pour traces)
  Serial.begin(4800);  // ou 9600 selon votre port COM
// on arme le grafcet
  grafcet_a = 1;
}
//**********************************************************
// PROGRAMME PRINCIPAL
void loop() {

// gestion des TEMPORISATIONS
  if (tempo_a > 0 ) tempo_a--;
  
//--------------------------------
// GRAFCET A
switch (grafcet_a) {

  case 1:
  if ( tempo_a == 0 ) {        // si la tempo est terminée,
    digitalWrite(led, HIGH);   // on allume la LED
    tempo_a = demiperiode;             // on arme la tempo
    grafcet_a++;               // et on passe à l'étape suivante
  }
  break;      // cette instruction vous fait sauter à la fin du "switch"
  // sinon, on continue, et cela fait perdre du temps, et il peut arriver que d'autre "case" fonctionnent ! 

  case 2:
  if ( tempo_a == 0 ) {
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
    tempo_a = demiperiode;             // on arme la tempo
    grafcet_a=1;               // on reboucle
  }    
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
      grafcet_a = 0; // on arrête
  break;
}      // fin du "switch"
// FIN GRAFCET A
//--------------------------------
// Bouton-poussoir
  bp_etat = !digitalRead(bp);
  if (!bp_memoire && bp_etat){
    Serial.print ("BOUTON appuy\xE9 grafcet_a=");
    Serial.print (grafcet_a);
    Serial.print (" tempo_a=");
    Serial.println (tempo_a);
  }
  if (bp_memoire && !bp_etat) {
    Serial.print ("BOUTON lach\xE9 grafcet_a=");
    Serial.print (grafcet_a);
    Serial.print (" tempo_a=");
    Serial.println (tempo_a);
  }
// mise en mémoire pour le prochain tour
  bp_memoire = bp_etat;
//--------------------------------

}
//**********************************************************

